package drew.figure;

import math.*;

public class VecPlot extends Plot implements java.io.Serializable
{
  Vec domain;
  public Vec getDomain() { return domain; }
  public void setDomain(Vec v) { domain = v; }
  
  Vec range;
  public Vec getRange() { return range; }
  public void setRange(Vec v) { range = v; }
  
  
  
  public int domainSize()
  {
    if (domain == null)
      return 0;
    else
      return domain.dim();
  }
  
  public double domainRef(int i)
  {
    return domain.ref(i);
  }
  
  
  public int rangeSize()
  {
    if (range == null)
      return 0;
    else return range.dim();
  }

  public double rangeRef(int i)
  {
    return range.ref(i);
  }

  
  public void defaultDomain()
  {
    domain = new Vec(rangeSize());
    for (int i = 0; i < rangeSize(); i++)
      domain.set(i, (double) i);
  }


}
