h = 1;
qt = 2;
v = 3;
pp = 4;
p = 5;
c = 6;

N = 6;
dag = zeros(N,N);
dag(h,qt) = 1;
dag(h,v) = 1;
dag(qt,v) = 1;
dag(h,pp) = 1;
dag(h,p) = 1;
dag(pp,p) = 1;
dag(v,p) = 1;


node_sizes = [2 4 2 2 2 3];

discrete_nodes = [h qt];

bnet = mk_bnet(dag, node_sizes, discrete_nodes);

bnet.bnodes{h} = mk_discrete_node(bnet, h);
bnet.bnodes{qt} = mk_discrete_node(bnet, qt);
bnet.bnodes{v} = mk_gaussian_node(bnet, v);
bnet.bnodes{pp} = mk_gaussian_node(bnet, pp);
bnet.bnodes{p} = mk_gaussian_node(bnet, p);
bnet.bnodes{c} = mk_gaussian_node(bnet, c);


bnet = compile_params(bnet);

[bnet, ll] = enter_evidence(bnet, [], []);
ll

