package drew.util;

import java.util.ArrayList;

public class ArrayListOps
{

  public static ArrayList reverse(ArrayList v)
  {
    ArrayList out = new ArrayList();
    for (int i = 0; i < v.size(); i++)
      out.add(0, v.get(i));
    return out;
  }

  public static ArrayList union(ArrayList a, ArrayList b)
  {
    ArrayList out = (ArrayList) a.clone();
    for (int i = 0; i < b.size(); i++)
      if (!a.contains(b.get(i)))
	out.add(b.get(i));
    return out;
  }

  public static ArrayList addAndReplace(ArrayList a, Object o)
  {
    ArrayList out = (ArrayList) a.clone();
    if (!out.contains(o))
      out.add(o);
    return out;
  }

  public static ArrayList setDifference(ArrayList a, ArrayList b)
  {
    ArrayList out = new ArrayList();
    for (int i = 0; i < a.size(); i++)
      if (!b.contains(a.get(i)))
	out.add(a.get(i));
    return out;
  }

  public static ArrayList intersect(ArrayList a, ArrayList b)
  {
    ArrayList out = new ArrayList();
    for (int i = 0; i < a.size(); i++)
      if (b.contains(a.get(i)))
	out.add(a.get(i));
    return out;
  }

  public static boolean subset(ArrayList a, ArrayList b)
  {
    boolean out = true;
    for (int i = 0; i < a.size(); i++)
      out = out && b.contains(a.get(i));
    return out;
  }

  public static ArrayList order(ArrayList a, ArrayList ordered)
  {
    Object[] bins = new Object[ordered.size()];
    for (int i = 0; i < a.size(); i++)
      bins[ordered.indexOf(a.get(i))] = a.get(i);
    
    ArrayList out = new ArrayList();
    for (int i = 0; i < bins.length; i++)
      if (bins[i] != null)
	out.add(bins[i]);
    return out;
  }

}
