package drew;

import java.io.*;
import javax.swing.*;

public class Redirect extends JTextArea
{

  public Redirect()
  {
    super(10,80);
  }
    

  class MyOutputStream extends OutputStream
  {

    public void write(int b)
    {
      System.err.println("wrote int " + b);
    }
  }

  class MyOutputStream2 extends ByteArrayOutputStream
  {
    
    public void write(byte[] b, int off, int len)
    {
      super.write(b,off,len);
      System.err.println("wrote " + len);
      //System.err.println("wrote: " + this.toString());

      append(this.toString());
      reset();
    }
    

    public void write(int b)
    {
      super.write(b);
      System.err.println("wrote int " + b);
    }
  }


  public void test()
  {
    PrintStream output = new PrintStream(new MyOutputStream2());
    System.setOut(output);

    System.out.println("hello");
    System.out.println("hello again");

  }

  public static void main(String args[])
  {
    JFrame frame = new JFrame();
    Redirect redirect = new Redirect();
    frame.setContentPane(redirect);
    frame.pack();
    frame.setVisible(true);

    redirect.test();





  }


}

