package drew.figure;

import math.*;

public class ArrayPlot extends Plot implements java.io.Serializable
{
  double[] domain;
  public double[] getDomain() { return domain; }
  public void setDomain(double[] a) { domain = a; }
  
  double[] range;
  public double[] getRange() { return range; }
  public void setRange(double[] a) { range = a; }
  
  
  
  public int domainSize()
  {
    if (domain == null)
      return 0;
    else
      return domain.length;
  }
  
  public double domainRef(int i)
  {
    return domain[i];
  }
  
  
  public int rangeSize()
  {
    if (range == null)
      return 0;
    else return range.length;
  }

  public double rangeRef(int i)
  {
    return range[i];
  }

  
  public void defaultDomain()
  {
    //System.out.println("defaultDomain()");
    domain = new double[rangeSize()];
    for (int i = 0; i < rangeSize(); i++)
      domain[i] = (double) i;
  }


}
