package math;
//package scoot.math.linalg;


/** Exception used to indicate when the dimensions of vector or matrix objects
    are inappropriate for the operation being performed (such as when
    multiplying matrices whose dimensions don't match correctly, or trying to
    copy a larger vector into a smaller one).  Runtime so need not be caught
    if you are careful with your calls.
*/
public class DimensionMismatchException extends RuntimeException
{
  public DimensionMismatchException()
  {
    super();
  		
		
}

  public DimensionMismatchException(String s)
  {
    super(s);
  }

	
	
}


