package math;
//package scoot.math.linalg;

/**
  Signals when an inplace multiply is attempted.
  This is a run-time exception, so does not NEED to be handled if you know your code won't do it.
  @see Matrix
  */
public class InPlaceMatrixMultException extends RuntimeException
{
  public InPlaceMatrixMultException()
    {
      super();
    		
		
}

  public InPlaceMatrixMultException(String s)
    {
      super(s);
    }
	
	
}

