package math;

import java.util.*;

public class InverseSpeed
{
  public InverseSpeed()
  {
    Random random = new Random(0);
    
    int N = 8;

    Matrix X = new Matrix(N,N);
    Matrix Xinv = new Matrix(N,N);

    for (int i = 0; i < N; i++)
      for (int j = 0; j < N; j++)
	X.set(i,j, random.nextDouble());
	


    long startTime = System.currentTimeMillis();
    
    for (int i = 0; i < 10000; i++)
      {
	
	try
	  {
	    X.inverse(Xinv);
	  }
	catch (Exception e)
	  {
	    e.printStackTrace();
	    System.exit(-1);
	  }

      }

    System.out.println(Xinv);
    
    System.out.println(System.currentTimeMillis() - startTime);



    
  }


  public static void main(String args[])
  {
    new InverseSpeed();
  }

}
